<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Grid_Upload.aspx.cs" Inherits="Grid_Upload" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:ScriptManager ID="ScriptManager1" runat="server">
        </asp:ScriptManager>
        
        <telerik:radscriptblock id="RadScriptBlock1" runat="server">
                <script type="text/javascript">
                    //On insert and update buttons click temporarily disables ajax to perform upload actions
                    function conditionalPostback(e, sender)
                    {
                        var theRegexp = new RegExp("\.UpdateButton$|\.PerformInsertButton$", "ig");
		                if (sender.EventTarget.match(theRegexp))
		                {
		                    var upload = $find(window['UploadId']);
            		        
		                    //AJAX is disabled only if file is selected for upload
		                    if(upload.getFileInputs()[0].value != "")
		                    {
		                        sender.EnableAjax = false;
		                    }
		                }
                    }     
                </script>
            </telerik:radscriptblock>
        <asp:hiddenfield id="ComboValue" runat="server" />
        <telerik:radajaxpanel id="RadAjaxPanel1" runat="server" clientevents-onrequeststart="conditionalPostback">
            <telerik:radprogressmanager id="RadProgressManager1" runat="server" />
            <telerik:radgrid runat="server" id="RadGrid1" pagesize="10" allowpaging="true" allowsorting="true"
                autogeneratecolumns="false" allowmultirowedit="false" width="97%" datasourceid="SqlDataSource1"
                onupdatecommand="RadGrid1_UpdateCommand" oninsertcommand="RadGrid1_InsertCommand"
                ondeletecommand="RadGrid1_DeleteCommand" skin="Web20" onitemdatabound="RadGrid1_ItemDataBound"
                showstatusbar="true">
                <pagerstyle mode="NextPrevAndNumeric" />
                <mastertableview width="100%" editmode="EditForms" commanditemdisplay="Top" datakeynames="ID">
                <columns>
                    <telerik:grideditcommandcolumn>
                    </telerik:grideditcommandcolumn>
                    <telerik:gridtemplatecolumn headertext="Image Name" uniquename="ImageName" sortexpression="Name">
                        <itemtemplate>
                            <asp:label runat="server" id="lblName" text='<%# Eval("Name") %>' />
                        </itemtemplate>
                        <edititemtemplate>
                            <asp:textbox runat="server" style="width: 205px; margin-left: 3px;" id="txbName"
                                text='<%# Bind("Name") %>' />
                            <asp:requiredfieldvalidator id="Requiredfieldvalidator1" runat="server" controltovalidate="txbName"
                                errormessage="Please, enter a name!" display="Dynamic" setfocusonerror="true">
                            </asp:requiredfieldvalidator>
                        </edititemtemplate>
                    </telerik:gridtemplatecolumn>
                    <telerik:gridtemplatecolumn headertext="Description" uniquename="Description" datafield="Description">
                        <itemtemplate>
                            <asp:label id="lblDescription" runat="server" text='<%# Eval("Description") %>' />
                        </itemtemplate>
                        <edititemtemplate>
                            <asp:textbox id="txbDescription" style="width: 205px; margin-left: 4px;" runat="server"
                                textmode="MultiLine" text='<%# Bind("Description") %>' />
                        </edititemtemplate>
                    </telerik:gridtemplatecolumn>
                    <telerik:gridtemplatecolumn headertext="Author" uniquename="Author">
                        <itemtemplate>
                            <asp:label id="lblAuthorName" runat="server" text='<%# Eval("AuthorName") %>'>
                            </asp:label>
                        </itemtemplate>
                        <edititemtemplate>
                            <telerik:radcombobox id="AuthorImagesList" runat="server"  
                                skin="Default" style="margin-left: 4px;"
                                width="205" 
                                allowcustomtext="false" 
                                datasourceid="SqlDataSource2" 
                                highlighttemplateditems="true" 
                                datavaluefield="ID"
                                datatextfield="AuthorName"
                                SelectedValue='<%#Bind("AuthorNameID") %>'>
                                <itemtemplate>                                
                                    <table style="border-bottom: 1px dotted #EFEFEF; margin-bottom: 10px; font-size: 11px;"  width="98%">
                                        <tr>
                                            <td>
                                                <img src='AuthorsImages/<%# DataBinder.Eval(Container.DataItem, "AuthorImageName") %>' alt="" />
                                            </td>
                                            <td>                                                
                                                <%# DataBinder.Eval(Container.DataItem, "AuthorName")%>
                                            </td>
                                        </tr>
                                    </table>                                       
                                </itemtemplate>
                                <items>
                                    <telerik:radcomboboxitem id="RadComboBoxItem1" runat="Server" selected="true" />
                                </items>
                            </telerik:radcombobox>
                            <asp:requiredfieldvalidator id="Requiredfieldvalidator2" runat="server" controltovalidate="AuthorImagesList"
                                display="Dynamic" errormessage="Please, select an author!" setfocusonerror="true" initialvalue="">
                            </asp:requiredfieldvalidator>
                                                 </edititemtemplate>
                    </telerik:gridtemplatecolumn>
                    <telerik:gridtemplatecolumn headertext="Image" uniquename="Upload">
                        <itemtemplate>
                            <a href="ShowImageCS.aspx?id=<%# Eval("ID") %>">
                                <asp:image runat="server" id="ImageThumbnail" alternatetext="Click here to open the real size image"
                                    imageurl='<%# "Thumbnails/" + Eval("ID") + Eval("Extension") %>'
                                    style="border-width: 0px;" />
                            </a>
                        </itemtemplate>
                        <edititemtemplate>
                            <telerik:radupload id="RadUpload1" runat="server" initialfileinputscount="1"
                                maxfileinputscount="1" controlobjectsvisibility="None" maxfilesize="1000000"
                                allowedfileextensions=".jpg,.bmp,.gif,.dib,.jpeg,.jpe,.jfif,.png,.tif,.tiff" />
                        </edititemtemplate>
                    </telerik:gridtemplatecolumn>
                    <telerik:gridbuttoncolumn headertext="Delete" text="Delete" commandname="Delete" uniquename="column">
                    </telerik:gridbuttoncolumn>
                </columns>
                <editformsettings>
                    <editcolumn uniquename="EditCommandColumn1">
                    </editcolumn>
                </editformsettings>
                <expandcollapsecolumn visible="False">
                    <headerstyle width="19px" />
                </expandcollapsecolumn>
                <rowindicatorcolumn visible="False">
                    <headerstyle width="20px" />
                </rowindicatorcolumn>
            </mastertableview>
            </telerik:radgrid>
        </telerik:radajaxpanel>
        <asp:sqldatasource id="SqlDataSource1" runat="server" connectionstring="<%$ ConnectionStrings:UploadInAjaxifiedGridConnectionString %>"
            providername="<%$ ConnectionStrings:UploadInAjaxifiedGridConnectionString.ProviderName %>" selectcommand="SELECT * 
            FROM [Images] INNER JOIN [Authors] ON [Images].[AuthorNameID] = [Authors].[ID]">
        </asp:sqldatasource>
        <asp:sqldatasource id="SqlDataSource2" runat="server" connectionstring="<%$ ConnectionStrings:UploadInAjaxifiedGridConnectionString %>"
            providername="<%$ ConnectionStrings:UploadInAjaxifiedGridConnectionString.ProviderName %>" selectcommand="SELECT * FROM [Authors]">
        </asp:sqldatasource>
    </div>
    </form>
</body>
</html>
